
#include "scia_L2MET.h"

/* Array with DSD Names */

char DS_NAME_SCI_RV__2P [2][29] = {
    "GEOLOCATION",
    "O3_VERTICAL_COLUMN" };


SCIA_err Read_SPH_SCI_RV__2P (FILE* unit, SPH_SCI_RV__2P *sph)

{
    int err;
    unsigned n;
    char nl[2];
    char *tmp = (char*) sph;
    /* Zeros in the complete structure, so all strings have trailing \0 */
    for (n=0; n<sizeof(SPH_SCI_RV__2P); n++)
	tmp[n] = 0;
    
    err = fscanf(unit,
		 "SPH_DESCRIPTOR=\"%28c\"%1c"
		 "STRIPLINE_CONTINUITY_INDICATOR=%4c%1c"
		 "SLICE_POSITION=%4c%1c"
		 "NUM_SLICES=%4c%1c"
		 "START_TIME=\"%27c\"%1c"
		 "STOP_TIME=\"%27c\"%1c"
		 "START_LAT=%11c<10-6degN>%1c"
		 "START_LONG=%11c<10-6degE>%1c"
		 "STOP_LAT=%11c<10-6degN>%1c"
		 "STOP_LONG=%11c<10-6degE>%1c"
		 "%c%1c"
		 "FITTING_ERROR_SUM=\"%4c\"%1c"
		 "DOAS_FITTING_WINDOW_0=\"%9c\"%1c"
		 ,
		 sph->sph_descriptor, nl,
		 sph->stripline_continuity_indicator, nl,
		 sph->slice_position, nl,
		 sph->num_slices, nl,
		 sph->start_time, nl,
		 sph->stop_time, nl,
		 sph->start_lat, nl,
		 sph->start_long, nl,
		 sph->stop_lat, nl,
		 sph->stop_long, nl,
		 sph->spare_1, nl,
		 sph->fitting_error_sum, nl,
		 sph->doas_fitting_window_0, nl );

    if ( strncmp ("SCI_RV__2P", sph->sph_descriptor,10) != 0)
	return SPH_ERROR;	
    if (err != 26)
	return SPH_ERROR;
    return OK;
}


void O3_met_getbin (FILE* unit, O3_met *var)
{
   MJD_getbin (unit, &var->dsr_time);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   float_getbin (unit, &var->o3_vcd);
   float_getbin (unit, &var->err_vcd);
}


void GeoN_L2MET_getbin (FILE* unit, GeoN_L2MET *var)
{
   MJD_getbin (unit, &var->dsr_time);
   char_getbin (unit, &var->attach_flag);
   ushort_getbin (unit, &var->integr_time);
   Coord_array_getbin (unit, var->coor_grd, 4);
}


    
